package xyz.mcutils.models.cache;

import lombok.Getter;
import lombok.ToString;
import xyz.mcutils.models.server.MinecraftServer;

@Getter
public class CachedBedrockMinecraftServer extends MinecraftServer {
    /**
     * The unique ID of this server.
     */
    private String id;

    /**
     * The edition of this server.
     */
    private Edition edition;

    /**
     * The version information of this server.
     */
    private Version version;

    /**
     * The gamemode of this server.
     */
    private GameMode gamemode;

    /**
     * The edition of a Bedrock server.
     */
    @Getter
    public enum Edition {
        /**
         * Minecraft: Pocket Edition.
         */
        MCPE,

        /**
         * Minecraft: Education Edition.
         */
        MCEE
    }

    /**
     * Version information for a server.
     */
    @Getter @ToString
    public static class Version {
        /**
         * The protocol version of the server.
         */
        private int protocol;

        /**
         * The version name of the server.
         */
        private String name;
    }

    /**
     * The gamemode of a server.
     */
    @Getter @ToString
    public static class GameMode {
        /**
         * The name of this gamemode.
         */
        private String name;

        /**
         * The numeric of this gamemode.
         */
        private int numericId;
    }
}
