package xyz.mcutils.models.dns.impl;

import io.micrometer.common.lang.NonNull;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import xyz.mcutils.models.dns.DNSRecord;

@Setter @Getter
@NoArgsConstructor
public final class SRVRecord extends DNSRecord {
    /**
     * The priority of this record.
     */
    private int priority;

    /**
     * The weight of this record.
     */
    private int weight;

    /**
     * The port of this record.
     */
    private int port;

    /**
     * The target of this record.
     */
    @NonNull private String target;
}